/*************************************************************************
 *                                                                       *
 * Tokamak Physics Engine, Copyright (C) 2002-2007 David Lam.            *
 * All rights reserved.  Email: david@tokamakphysics.com                 *
 *                       Web: www.tokamakphysics.com                     *
 *                                                                       *
 * This library is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files    *
 * LICENSE.TXT for more details.                                         *
 *                                                                       *
 *************************************************************************/
#include <stdlib.h>

NEINLINE void neSeed(u32 seed) {
  srand(seed);
}

NEINLINE f32 neFRand( f32 Min, f32 Max ) {
  ASSERT( Max >= Min );
  f32 range = Max-Min;
  f32 scale = (f32)rand() / (f32)RAND_MAX;
  return  Min + range * scale;
}

NEINLINE f32 neSin(f32 S) {
  return sinf(S);
}

NEINLINE f32 neCos(f32 C) {
  return cosf(C);
}

NEINLINE f32 neASin(f32 S) {
  return asinf(S);
}

NEINLINE f32 neACos(f32 C) {
  return acosf(C);
}

NEINLINE f32 neTan(f32 T) {
  return tanf(T);
}

NEINLINE f32 neATan(f32 T) {
  return atanf(T);
}

NEINLINE f32 neATan2(f32 y, f32 x) {
  return atan2f(y, x);
}

NEINLINE neBool neRealsEqual(f32 s1, f32 s2) {
  if ( (2.0f * neAbs(s1 - s2) / (s1 + s2)) < NE_ZERO ) {
    return true;
  }
  return false;
}

NEINLINE neBool neIsConsiderZero(f32 f) {
  return (neAbs(f) < NE_ZERO);
}
