/*************************************************************************
 *                                                                       *
 * Tokamak Physics Engine, Copyright (C) 2002-2007 David Lam.            *
 * All rights reserved.  Email: david@tokamakphysics.com                 *
 *                       Web: www.tokamakphysics.com                     *
 *                                                                       *
 * This library is distributed in the hope that it will be useful,       *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the files    *
 * LICENSE.TXT for more details.                                         *
 *                                                                       *
 *************************************************************************/
#ifndef __GNUC__
#pragma inline_recursion( on )
#pragma inline_depth( 250 )
#endif

#include "stdio.h"

#include "tokamak.h"
#include "containers.h"
#include "scenery.h"
#include "collision.h"
#include "constraint.h"
#include "rigidbody.h"
#include "scenery.h"
#include "stack.h"
#include "simulator.h"
#include "message.h"

/****************************************************************************
*  neCollisionBody_::UpdateAABB
****************************************************************************/
void neCollisionBody_::UpdateAABB(){
  if (col.convexCount == 0 && !isCustomCD){
    return;
  }
  neT3 c2w = b2w * obb;
  neV3 &pos = c2w.pos;
  int i;
  for (i = 0; i < 3; i++)  {
    f32 a = neAbs(c2w.rot[0][i]) + neAbs(c2w.rot[1][i]) + neAbs(c2w.rot[2][i]);
    minBound[i] = pos[i] - a;
    maxBound[i] = pos[i] + a;
    if (minCoord[i]){
      minCoord[i]->value = pos[i] - a;
    }
    if (maxCoord[i]){
      maxCoord[i]->value = pos[i] + a;
    }
  }
};
/****************************************************************************
*  neCollisionBody_::Free
****************************************************************************/
void neCollisionBody_::Free(){
  neRigidBodyBase::Free();
  RemoveConstraintHeader();
}
